--- :profile.py	2001-10-19 17:13:51.000000000 +0200
+++ profile.py	2003-05-30 07:38:50.000000000 +0200
@@ -236,6 +236,19 @@
 
     def trace_dispatch_call(self, frame, t):
         if self.cur and frame.f_back is not self.cur[-2]:
+          if getattr(frame.f_back,'f_back',None) is self.cur[-2]:
+              # this can happen becauses at the end
+              # of a function call Python's main interpreter loop
+              # calls "call_trace(...,'Return',...)" (which pops "self.cur")
+              # and then "reset_exc_info". When "reset_exc_info" calls
+              # a destructor, we observe the resulting inconsistency
+              # between runtime stack (function frame not popped)
+              # and profiler stack (function frame popped)
+              #
+              # We simply fall through and associate the destructor with
+              # the function's caller
+              pass
+          else:
             rt, rtt, rct, rfn, rframe, rcur = self.cur
             if not isinstance(rframe, Profile.fake_frame):
                 if rframe.f_back is not frame.f_back:

 	  	 
